;source code for sampled sound playback routine
;programmed using devpac st
;by Tristan Hunting
;for ST Format

	opt p+,o+,d-

;variables: sample address, length, rate, space
vbls	ds.l	4

smp_cmnd
	movem.l		a0-a3/d0-d4,-(sp)	save registers
	move.w		#8,-(sp)
	move.w		#27,-(sp)
	trap		#14
	addq.l		#4,sp			enable timer b interrupt
	bsr		super			call supervisor mode
	move.b		#0,$fffa1b		stop timer b
	move		#7,-(sp)
	clr		-(sp)
	move		#28,-(sp)
	trap		#14
	addq.l		#6,sp			read sound chip port 7
	lea		port7(pc),a0
	move.b		d0,(a0)			save port 7
	and.w		#192,d0
	add.w		#63,d0
	move		#135,-(sp)
	move		d0,-(sp)
	move		#28,-(sp)
	trap		#14
	addq.l		#6,sp			load new value to port 7
	move.l		#$ff8800,a0				
	move.l		#$ff8802,a1		sound chip address
	lea		sup(pc),a2		data for setting up sound chip
	move.l		#9,d0
slp	move.b		(a2)+,(a0)
	move.b		(a2)+,(a1)
	dbf		d0,slp			set up sound chip
	lea		spa(pc),a0		address of interrupt routine variables
	lea		vbls(pc),a1		address of basic variables
	move.l		(a1)+,(a0)+		transfer address of sample data
	move.l		(a1)+,(a0)+		transfer length of sample
	move.l		(a1),d0			load coded sample rate
	mulu		#4,d0			multiply for position in data table
	lea		sdt(pc),a2		load address of data table
	lea		ntbint(pc),a3		load address of interrupt routine
	move.l		a3,-(sp)		
	move.w		0(a2,d0),-(sp)
	move.w		2(a2,d0),-(sp)
	move.w		#1,-(sp)
	move.w		#31,-(sp)
	trap		#14
	add.l		#12,sp			start timer b
	bsr		usuper			exit supervisor mode
	movem.l		(sp)+,a0-a3/d0-d4	load registers
	rts					and exit...

spa	ds.l	2				interrupt routine variables
sup	dc.b	10,0,9,0,8,0,11,0,12,0		data for sound chip set up
sd	dc.b	10,0,9,0,8,0			data for sound chip shut down
port7	dc.l	0				port7

;TIMER B INTERRUPT

ntbint
	movem.l		a0-a2/d0-d2,-(sp)	save registers
	lea.l		stable(pc),a1		address of data table
	lea.l		spa(pc),a2		variables address
	subq.l		#1,4(a2)
	beq		spexit			decrement and test counter
	move.l		(a2),a0			sample address
	addq.l		#1,(a2)			increment sample address
	clr.l		d1
	clr.l		d2			clear data registers
	move.b		(a0),d1			read sample
	eori.b		#128,d1			sign sample
	lsl		#1,d1			byte to word value
	move.b		(a1,d1.w),d0		read data from sound table
	move.b		$1(a1,d1.w),d1		data to voice c register
	move		d0,d2
	lsr		#4,d2			put volume in lowest nibble
	andi		#$f,d0			mask voice b
	move.b		#8,$ff8800		select voice a
	move.b		d2,$ff8802		write volume
	move.b		#9,$ff8800		select voice b
	move.b		d1,$ff8802		write volume
	move.b		#$a,$ff8800		select voice c
	move.b		d0,$ff8802		write volume
	movem.l		(sp)+,a0-a2/d0-d2	load registers
	bclr		#0,$fffa0f		acknowledge interrupt
	rte					and exit...
spexit
	move.l		#$ff8800,a0		
	move.l		#$ff8802,a1		sound chip address for fast accsess
	lea		sd(pc),a2		data for sound chip shut down 
	move.l		#5,d0
selp	move.b		(a2)+,(a0)
	move.b		(a2)+,(a1)
	dbf		d0,selp			output data
	lea		port7(pc),a2
	move.b		#7,(a0)
	move.b		(a2),(a1)		load port 7
	movem.l		(sp)+,a0-a2/d0-d2	load registers	
	move.b		#0,$fffa1b		timer b	off
	bclr		#0,$fffa0f		acknowledge interrupt
	rte					and exit
stable
	DC.W	$0000
	DC.W	$0000
	DC.W	$0001
	DC.W	$0002
	DC.W	$0003
	DC.W	$0004
	DC.W	$0004
	DC.W	$0005
	DC.W	$0005
	DC.W	$0005
	DC.W	$0006
	DC.W	$0006
	DC.W	$0006	
	DC.W	$0006
	DC.W	$0007
	DC.W	$0007
	DC.W	$0007
	DC.W	$0007
	DC.W	$0007
	DC.W	$0008
	DC.W	$0008
	DC.W	$0008
	DC.W	$0008
	DC.W	$0008
	DC.W	$0208
	DC.W	$0308
	DC.W	$0308
	DC.W	$0408
	DC.W	$0408
	DC.W	$0009
	DC.W	$0009
	DC.W	$0009
	DC.W	$0009
	DC.W	$0209
	DC.W	$0309
	DC.W	$0309
	DC.W	$0409
	DC.W	$0409
	DC.W	$0509
	DC.W	$0509
	DC.W	$0509
	DC.W	$0509
	DC.W	$0609
	DC.W	$0609
	DC.W	$0609
	DC.W	$0609
	DC.W	$000A
	DC.W	$020A
	DC.W	$030A
	DC.W	$040A
	DC.W	$040A
	DC.W	$050A
	DC.W	$050A
	DC.W	$050A
	DC.W	$060A
	DC.W	$060A
	DC.W	$060A
	DC.W	$160A
	DC.W	$160A
	DC.W	$000B
	DC.W	$000B
	DC.W	$000B
	DC.W	$010B
	DC.W	$010B
	DC.W	$020B
	DC.W	$030B
	DC.W	$030B
	DC.W	$040B
	DC.W	$0408	
	DC.W	$050B
	DC.W	$050B
	DC.W	$060B
	DC.W	$060B
	DC.W	$060B
	DC.W	$160B
	DC.W	$070B
	DC.W	$070B
	DC.W	$070B
	DC.W	$170B
	DC.W	$170B
	DC.W	$270B
	DC.W	$080B
	DC.W	$180B
	DC.W	$280B
	DC.W	$380B
	DC.W	$380B
	DC.W	$480B
	DC.W	$480B
	DC.W	$480B
	DC.W	$000C
	DC.W	$010C
	DC.W	$020C
	DC.W	$030C
	DC.W	$030C
	DC.W	$040C
	DC.W	$040C
	DC.W	$050C
	DC.W	$250C
	DC.W	$060C
	DC.W	$060C
	DC.W	$360C
	DC.W	$070C
	DC.W	$270C
	DC.W	$370C
	DC.W	$470C
	DC.W	$470C
	DC.W	$080C
	DC.W	$280C
	DC.W	$280C
	DC.W	$380C
	DC.W	$380C
	DC.W	$480C
	DC.W	$480C
	DC.W	$580C
	DC.W	$580C
	DC.W	$090C
	DC.W	$290C
	DC.W	$390C
	DC.W	$490C
	DC.W	$490C
	DC.W	$590C
	DC.W	$590C
	DC.W	$000D
	DC.W	$010D
	DC.W	$020D
	DC.W	$030D
	DC.W	$040D
	DC.W	$040D
	DC.W	$050D
	DC.W	$050D
	DC.W	$060D
	DC.W	$060D
	DC.W	$070D
	DC.W	$070D
	DC.W	$270D
	DC.W	$270D
	DC.W	$370D
	DC.W	$370D
	DC.W	$080D
	DC.W	$080D
	DC.W	$180D
	DC.W	$280D
	DC.W	$280D
	DC.W	$380D
	DC.W	$480D
	DC.W	$090D
	DC.W	$290D
	DC.W	$390D
	DC.W	$490D
	DC.W	$590D
	DC.W	$690D
	DC.W	$0A0D
	DC.W	$2A0D
	DC.W	$3A0D
	DC.W	$4A0D
	DC.W	$5A0D
	DC.W	$5A0D
	DC.W	$6A0D
	DC.W	$6A0D
	DC.W	$7A0D
	DC.W	$7A0D
	DC.W	$0B0D
	DC.W	$0B0D
	DC.W	$3B0D
	DC.W	$4B0D
	DC.W	$4B0D
	DC.W	$5B0D
	DC.W	$5B0D
	DC.W	$6B0D
	DC.W	$6B0D
	DC.W	$6B0D
	DC.W	$7B0D
	DC.W	$7B0D
	DC.W	$7B0D
	DC.W	$8B0D
	DC.W	$8B0D
	DC.W	$8B0D
	DC.W	$8B0D
	DC.W	$8B0D
	DC.W	$000E
	DC.W	$000E
	DC.W	$010E
	DC.W	$020E
	DC.W	$030E
	DC.W	$040E
	DC.W	$040E
	DC.W	$050E
	DC.W	$050E
	DC.W	$060E
	DC.W	$060E
	DC.W	$260E
	DC.W	$070E
	DC.W	$070E
	DC.W	$270E
	DC.W	$080E
	DC.W	$080E
	DC.W	$090E
	DC.W	$490E
	DC.W	$590E
	DC.W	$690E
	DC.W	$0A0E
	DC.W	$0A0E
	DC.W	$3A0E
	DC.W	$3A0E
	DC.W	$5A0E
	DC.W	$5A0E
	DC.W	$6A0E
	DC.W	$6A0E
	DC.W	$7A0E
	DC.W	$7A0E
	DC.W	$0B0E
	DC.W	$4B0E
	DC.W	$4B0E
	DC.W	$5B0E
	DC.W	$5B0E
	DC.W	$6B0E
	DC.W	$6B0E
	DC.W	$7B0E
	DC.W	$7B0E
	DC.W	$8B0E
	DC.W	$8B0E
	DC.W	$9B0E
	DC.W	$9B0E
	DC.W	$9B0E
	DC.W	$9B0E
	DC.W	$0C0E
	DC.W	$0C0E
	DC.W	$3C0E
	DC.W	$7C0E
	DC.W	$8C0E
	DC.W	$8C0E
	DC.W	$8C0E
	DC.W	$8C0E
	DC.W	$8C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$9C0E
	DC.W	$AC0E
	DC.W	$AC0E
	DC.W	$AC0E
	DC.W	$AC0E
	DC.W	$AC0E
	DC.W	$AC0E
	DC.W	$000F
	DC.W	$060F
	DC.W	$060F
	DC.W	$070F
	DC.W	$070F
	DC.W	$070F
	DC.W	$080F   
	DC.W	$080F   
	DC.W	$080F			data for sampled sounds			

super
	clr.l	-(sp)
	move.w	#$20,-(sp)
	trap	#1
	add.l	#$6,sp			call supervisor
	lea	stksve(pc),a0
	move.l	d0,(a0)			save stack
	rts				and exit...

usuper
	lea	stksve(pc),a0
	move.l	(a0),d0
	move.l	d0,-(sp)		load stack
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp			back to user mode
	rts	and exit...

; data table for sample rates (data, control(timer b registers))
sdt	dc.w	$E2,2,$E2,2,$76,2,$CA,1,$98,1
	dc.w	$79,1,$65,1,$56,1,$50,1,$45,1
	dc.w	$39,1,$36,1,$33,1,$30,1,$27,1
	dc.w	$21,1,$10,1

stksve	ds.l	1			stack save
